import {
  Controller,
  Get,
  Param,
  Post,
  UseInterceptors,
  ClassSerializerInterceptor,
} from '@nestjs/common';
import { ReplayService } from './replay.service';
import { Roles } from 'src/shared/guard.decorator';

/*
POST mockdata is mainly used for development, it can be removed from the code when needed, remember to remove service & test relations.
*/

@Controller('replay')
export class ReplayController {
  constructor(private replayservice: ReplayService) {}

  // gets replay data for specified Game
  @Get(':id')
  @UseInterceptors(ClassSerializerInterceptor)
  async replayInfo(@Param('id') gameId) {
    return this.replayservice.replayData(gameId);
  }

  // gets mockdata for specified Game
  @Post('mockdata/:id')
  @Roles('admin')
  async mockData(@Param('id') gameId) {
    return this.replayservice.mockdata(gameId);
  }
}
